"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRefValue = void 0;
var react_1 = require("react");
var DEFAULT_OPTIONS = {
    refreshIntervalMs: 1000,
};
var useRefValue = function (targetRef, options) {
    var _a = (0, react_1.useState)(null), value = _a[0], setValue = _a[1];
    var _options = (0, react_1.useMemo)(function () { return (__assign(__assign({}, DEFAULT_OPTIONS), options)); }, [options]);
    (0, react_1.useEffect)(function () {
        var intervalId = setInterval(function () {
            var target = targetRef.current;
            setValue(function (prev) { return (prev === target ? prev : target); });
        }, _options.refreshIntervalMs);
        return function () { return clearInterval(intervalId); };
    }, [_options, targetRef]);
    return value;
};
exports.useRefValue = useRefValue;
