"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useWindowSize = void 0;
var just_throttle_1 = __importDefault(require("just-throttle"));
var react_1 = require("react");
var useWindowSize = function (options) {
    if (options === void 0) { options = {}; }
    var _a = (0, react_1.useState)({
        width: typeof window !== 'undefined' ? window.innerWidth : Infinity,
        height: typeof window !== 'undefined' ? window.innerHeight : Infinity,
    }), state = _a[0], setState = _a[1];
    var resizeEffect = (0, react_1.useMemo)(function () {
        return (0, just_throttle_1.default)(function () {
            setState({
                width: window.innerWidth,
                height: window.innerHeight,
            });
        }, options.waitingMs || 0);
    }, [options.waitingMs]);
    (0, react_1.useEffect)(function () {
        window.addEventListener('scroll', resizeEffect, options);
        return function () {
            window.removeEventListener('scroll', resizeEffect);
        };
    }, [options, resizeEffect]);
    return state;
};
exports.useWindowSize = useWindowSize;
